require "platforms"
require "camera"
player = {}
player.picData = love.image.newImageData("Images/Snuffy/Idle.png")
player.picWidth, player.picHeight = player.picData:getDimensions()
player.defaultx = 1
player.defaulty = platforms.platform1.y - player.picHeight
player.x = player.defaultx
player.y = player.defaulty
player.oldx = player.x
player.oldy = player.y
player.xfixed = false
player.speed = 1400
player.xvel = 0
player.friction = 7
player.yvel = 0
player.defaultgravity = 500
player.gravity = player.defaultgravity
player.state = "running"
player.picSide = {}
player.picSide[1] = love.graphics.newImage("Images/Snuffy/Idle.png")
player.picSide[2] = love.graphics.newImage("Images/Snuffy/Walking 1.png")
player.picSide[3] = love.graphics.newImage("Images/Snuffy/Walking 2.png")
player.picSide[4] = love.graphics.newImage("Images/Snuffy/Walking 3.png")
player.animtimer = 0 
player.pic = player.picSide[1]
player.picNum = 1
player.facing = "right"
player.idleTimer = 0
player.idleTimerActive = true
player.respawnTimer = 0
player.lives = 3
player.groundCollisionCounter = 0

function player.idle(dt)
	if not love.keyboard.isDown(" ") and not love.keyboard.isDown("right") and not love.keyboard.isDown("left") then
		if player.idleTimer >= 15 then
			player.picNum = 1
			player.pic = player.picSide[player.picNum]
			player.idleTimer = 0
			player.idleTimerActive = false
		end
		if player.idleTimerActive then
			player.idleTimer = player.idleTimer + dt
		end
	end	
end

function player.move(dt)
	if not player.xfixed then
		if love.keyboard.isDown("right") and
		player.xvel < player.speed then
			player.facing = "right"
			player.pic = player.picSide[player.picNum]
			player.xvel = player.xvel + player.speed * dt
			player.animtimer = player.animtimer + dt
			if player.animtimer > 0.1 then
				player.picNum = player.picNum + 1
				player.animtimer = 0
			end
			if player.picNum > #player.picSide then
				player.picNum = 2
			end
			player.idleTimerActive = true
			player.idleTimer = 0
		end
		if love.keyboard.isDown("left") and player.xvel > -player.speed then
			player.facing = "left"
			player.pic = player.picSide[player.picNum]
			player.xvel = player.xvel - player.speed * dt
			player.animtimer = player.animtimer + dt
			if player.animtimer > 0.1 then
				player.picNum = player.picNum + 1
				player.animtimer = 0
			end
			if player.picNum > #player.picSide then
				player.picNum = 2
			end
			player.idleTimerActive = true
			player.idleTimer = 0
		end
	end
	if love.keyboard.isDown(" ")then
		if player.yvel <= 0 then
			player.state = "jumping"
			player.yvel = 600
		end
	end
	if(player.state == "jumping" or player.state == "falling") then
		if player.yvel < 0 then
			player.state = "falling"
		end
		player.y = player.y - player.yvel * dt
		player.yvel = player.yvel - dt * player.gravity
	end
end

function player.collision(dt)
	for k,v in pairs(platforms) do
		if player.y + player.picHeight > v.y and player.y < v.y + v.picHeight then
			firstifstatement = true
			if player.x + player.picWidth > v.x and player.x < v.x + v.picWidth then
				secondifstatement = true
				if player.oldx + player.picWidth < v.x then
					thirdifstatement = true
					player.x = v.x - player.picWidth - 1
				elseif player.oldx > v.x + v.picWidth then
					fourthifstatement = true
					player.x = v.x + v.picWidth + 1
				end
			else player.xfixed = false
			end
		end
		if player.x + player.picWidth > v.x and player.x < v.x + v.picWidth then
			if player.y + player.picHeight > v.y then 
				player.yvel = 0
				player.state = "running"
				player.y = v.y - player.picHeight
			end
		end
		if player.state == "running" then
			if player.x > v.x and player.x < v.x + v.picWidth and player.y + player.picHeight == v.y - 1 then
				placeholder = true
			elseif player.x > v.x or player.x < v.x + v.picWidth or player.y + player.picHeight ~= v.y - 1 then
				player.groundCollisionCounter = player.groundCollisionCounter + 1
				if player.groundCollisionCounter == platformsNum then
					player.state = "falling"
					player.yvel = -1
				end
			end
		end
	end
	player.groundCollisionCounter = 0
end

function player.physics(dt)
	player.oldx = player.x
	player.oldy = player.y
	if not player.xfixed then
		player.x = player.x + player.xvel * dt
		player.xvel = player.xvel * (1 - math.min(dt*player.friction,1))
	end
end

function player.animreset(key)
	if key == "right" or key == "left" then
		animtimer = 0
		player.picNum = 2
	end
end

function player.respawn()
	player.lives = player.lives - 1
	player.y = player.defaulty
	player.x = player.defaultx
	camera.x = player.defaultx
end

function player.boundry(dt)
	if player.x < 1 then player.x = player.defaultx end
	if player.y > screenheight then
		player.respawnTimer = player.respawnTimer + dt
		if player.respawnTimer >= 2 then
			player.respawnTimer = 0
			player.respawn()
		end
	end
end

function player.draw()
	if player.facing == "right" then
		love.graphics.draw(player.pic,player.x,player.y)
	elseif player.facing == "left" then
		love.graphics.draw(player.pic,player.x,player.y,math.rad(180), 1, -1,player.picWidth,0)
	end
end




function UPDATE_PLAYER(dt)
	player.physics(dt)
	player.move(dt)
	player.boundry(dt)
	player.collision(dt)
	player.idle(dt)
end
function DRAW_PLAYER()
	player.draw()
end